unit unitformabout;

interface

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning about dialog.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ShellAPI, ExtCtrls;

type
  TformAbout = class(TForm)
    gbContributions: TGroupBox;
    lBassLibrary: TLabel;
    lSmallPort: TLabel;
    lDelphi: TLabel;
    lBassLibrary2: TLabel;
    lSmallPort2: TLabel;
    lDelphi2: TLabel;
    lBeta: TLabel;
    gbCopyright: TGroupBox;
    labelCopyright: TLabel;
    labelCopyright2: TLabel;
    lDelphi3: TLabel;
    lBass3: TLabel;
    lSools: TLabel;
    lLUA: TLabel;
    lLUA2: TLabel;
    lLUA3: TLabel;
    lSmallPort3: TLabel;
    lWSockets: TLabel;
    lWSockets2: TLabel;
    lWSockets3: TLabel;
    lNTKbdLites: TLabel;
    lNTKbdLites2: TLabel;
    lNTKbdLites3: TLabel;
    imageIcon: TImage;
    imageIcon2: TImage;
    buttonOK: TButton;
    labelXdom: TLabel;
    labelXdom2: TLabel;
    labelXdom3: TLabel;
    lVistaAltFix: TLabel;
    lVistaAltFix2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lBassLibraryClick(Sender: TObject);
    procedure lLUAClick(Sender: TObject);
    procedure lWSocketsClick(Sender: TObject);
    procedure labelXdomClick(Sender: TObject);
    procedure labelLinkClick(Sender: TObject);
    procedure labelMailClick(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure labelCopyright2Click(Sender: TObject);
    procedure lBetaClick(Sender: TObject);
  private
    { Private declarations }
    frame: TFrame;
  public
    { Public declarations }
  end;

var
  formAbout: TformAbout;

implementation

{$R *.DFM}

uses
  unitlightningsettings,
  unitframeaboutcopyright, unitframeaboutbeta, unitframeaboutlua,
  unitframeaboutbasslibrary, unitframeaboutwsockets, unitframeaboutxdom;

procedure TformAbout.FormCreate(Sender: TObject);
begin
  frame := nil;
  imageIcon.Picture.Icon.Assign(Application.Icon);
  imageIcon2.Picture.Icon.Assign(Application.Icon);
  Caption := 'About Lightning V' + lightningVersion;
  labelCopyright2.Caption :=
    'This program is freeware.  The software is provided as is, without any warrantees.  ' +
    'You are granted a license to use the software free of charge at your own risk.  '#13#10 +
    'The source code is available under the terms of the Mozilla Public License V1.1.  '#13#10 +
    'If you like the software, please send me some feedback.  Thanks !';
end;

procedure TformAbout.lBassLibraryClick(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutBASSLibrary.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.lLUAClick(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutLUA.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.lWSocketsClick(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutWSockets.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.labelXdomClick(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutXdom.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.labelCopyright2Click(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutCopyright.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.lBetaClick(Sender: TObject);
begin
  if frame <> nil then
    frame.Free();
  frame := TframeAboutBeta.Create(Self);
  with frame do
  begin
    Top := gbCopyright.Top;
    Left := gbCopyright.Left;
    Parent := Self;
  end;
end;

procedure TformAbout.labelLinkClick(Sender: TObject);
var
  url: string;
begin
  url := 'http://' + TLabel(Sender).Caption + '/';
  ShellExecute(Handle, 'open', PChar(url), nil, nil, SW_SHOWNORMAL);
end;

procedure TformAbout.labelMailClick(Sender: TObject);
var
  url: string;
begin
  url := 'mailto:' + TLabel(Sender).Caption;
  ShellExecute(Handle, 'open', PChar(url), nil, nil, SW_SHOWNORMAL);
end;

procedure TformAbout.FormHide(Sender: TObject);
begin
  if frame <> nil then
  begin
    frame.Free();
    frame := nil;
  end;
end;

end.
