unit unitformdlop;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning DLOP compatibility dialog.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TformDLOP = class(TForm)
    groupBoxDLOP: TGroupBox;
    buttonOK: TButton;
    buttonCancel: TButton;
    labelDLOP: TLabel;
    listBoxDLOP: TListBox;
    procedure listBoxDLOPDblClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function getFileName(): string;
  end;

var
  formDLOP: TformDLOP;

implementation

{$R *.dfm}

uses
  unitformlightning, unitmodule;

procedure TformDLOP.listBoxDLOPDblClick(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TformDLOP.FormShow(Sender: TObject);
var
  i: Integer;
begin
  with listBoxDLOP do
  begin
    Clear();
    for i := 0 to Length(externals) - 1 do
    begin
      if externals[i].moduleKind = mkDLOP then
      begin
        Items.Add(externals[i].fileName);
      end;
    end;
  end;
  if listBoxDLOP.Count > 0 then
  begin
    listBoxDLOP.ItemIndex := 0;
    listBoxDLOP.SetFocus();
  end
  else
    ModalResult := mrCancel;
end;

function TformDLOP.getFileName(): string;
begin
  if listBoxDLOP.ItemIndex > -1 then
    Result := listBoxDLOP.Items[listBoxDLOP.ItemIndex];
end;

end.
