unit unitformlightning;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning main window.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

interface

uses
  Windows, Messages, SysUtils, Graphics, Forms, Menus, StdCtrls, ExtCtrls,
  Dialogs, Controls, Classes, Math, ComCtrls, AppEvnts, Registry,
  ShellAPI, ImgList, VistaAltFixUnit,
  common, unitlightningsettings, unitthreadtimer, unitdesktopview,
  unitmodule, unitmoduledlop, unitmodulelua, dlua,
  unitformdetails, ToolWin;

const
  WM_NOTIFYICON = WM_USER + 333;

  defaultTop     = 10;
  defaultLeft    = 300;
  disableConfirm = True;

  MAX_MODULES = 1024;

type
  TProgram = TList; // of TScene
  TProgramList = TStringList; // of program number//TList; //// of TProgram
  TExternal = record
    fileName, filePath:  string;
    moduleKind: TModuleKind;
    hInstance: THandle;
  end;
  PExternal = ^TExternal;
  TformLightning = class(TForm)
    sdSave: TSaveDialog;
    odLoad: TOpenDialog;
    mmLightning: TMainMenu;
    miFile: TMenuItem;
    miNew: TMenuItem;
    miOpen: TMenuItem;
    miSave: TMenuItem;
    miInput: TMenuItem;
    miProcess: TMenuItem;
    miOutput: TMenuItem;
    miHelp: TMenuItem;
    miContents: TMenuItem;
    N1: TMenuItem;
    miAbout: TMenuItem;
    miTools: TMenuItem;
    N2: TMenuItem;
    miVisualiseDataFlow: TMenuItem;
    miPause: TMenuItem;
    tLoad: TTimer;
    miPaintUnpoweredLines: TMenuItem;
    pmPopup: TPopupMenu;
    miInputEnd: TMenuItem;
    miProcessEnd: TMenuItem;
    aeEvents: TApplicationEvents;
    miView: TMenuItem;
    miStatusBar: TMenuItem;
    miLock: TMenuItem;
    miVisualiseShades: TMenuItem;
    miSaveAs: TMenuItem;
    N3: TMenuItem;
    miExit: TMenuItem;
    miSceneManagerHotkeys: TMenuItem;
    miSceneNew: TMenuItem;
    miSceneRecall: TMenuItem;
    miSceneStore: TMenuItem;
    miComponents: TMenuItem;
    miLUA: TMenuItem;
    miProgramManager: TMenuItem;
    miSceneManager: TMenuItem;
    pmContext: TPopupMenu;
    miContextExcludeModuleFromFadeTime: TMenuItem;
    miContextApplytoAllScenesinCurrentProgram: TMenuItem;
    miContextSeparator: TMenuItem;
    miDisplayValues512: TMenuItem;
    miDisplayValues256: TMenuItem;
    N5: TMenuItem;
    miContextSeparator2: TMenuItem;
    miDLOP: TMenuItem;
    miContextBringToFront: TMenuItem;
    miContextSendToBack: TMenuItem;
    miConfiguration: TMenuItem;
    miContextSetModuleColor: TMenuItem;
    miEdit: TMenuItem;
    miCut: TMenuItem;
    miCopy: TMenuItem;
    miPaste: TMenuItem;
    miDelete: TMenuItem;
    miSelectAll: TMenuItem;
    N7: TMenuItem;
    ilToolbar: TImageList;
    miAlwaysFinishFades: TMenuItem;
    miContextCut: TMenuItem;
    miContextCopy: TMenuItem;
    miContextDelete: TMenuItem;
    miBringToFront: TMenuItem;
    miSendToBack: TMenuItem;
    N6: TMenuItem;
    statusBar: TStatusBar;
    miPasteArray: TMenuItem;
    miPaintHighlightedLines: TMenuItem;
    N9: TMenuItem;
    N10: TMenuItem;
    menuItemOpenFromXML: TMenuItem;
    openDialogXML: TOpenDialog;
    saveDialogXML: TSaveDialog;
    miLayer: TMenuItem;
    menuItemSaveToXML: TMenuItem;
    miOutputEnd: TMenuItem;
    miPopupDLOP: TMenuItem;
    miPopupComponents: TMenuItem;
    miPopupLUA: TMenuItem;
    N4: TMenuItem;
    menuItemStresstestScreenStick: TMenuItem;
    menuItemTrace: TMenuItem;
    miDisplayValues100: TMenuItem;
    N11: TMenuItem;
    miDisplayValues128: TMenuItem;
    N12: TMenuItem;
    N13: TMenuItem;
    toolBar: TToolBar;
    toolButtonNew: TToolButton;
    toolButtonOpen: TToolButton;
    toolButtonSave: TToolButton;
    toolButtonSeperator: TToolButton;
    toolButtonCut: TToolButton;
    toolButtonCopy: TToolButton;
    toolButtonPaste: TToolButton;
    toolButtonPasteArray: TToolButton;
    toolButtonDelete: TToolButton;
    miToolBar: TMenuItem;
    miShowLayer0: TMenuItem;
    menuItemShowLayer1: TMenuItem;
    menuItemShowLayer7: TMenuItem;
    menuItemShowLayer6: TMenuItem;
    menuItemShowLayer5: TMenuItem;
    menuItemShowLayer4: TMenuItem;
    menuItemShowLayer3: TMenuItem;
    menuItemShowLayer2: TMenuItem;
    menuItemShowLayer9: TMenuItem;
    menuItemShowLayer8: TMenuItem;
    menuItemSetLayer: TMenuItem;
    menuItemSetLayer0: TMenuItem;
    menuItemSetLayer1: TMenuItem;
    menuItemSetLayer2: TMenuItem;
    menuItemSetLayer3: TMenuItem;
    menuItemSetLayer4: TMenuItem;
    menuItemSetLayer5: TMenuItem;
    menuItemSetLayer6: TMenuItem;
    menuItemSetLayer7: TMenuItem;
    menuItemSetLayer8: TMenuItem;
    menuItemSetLayer9: TMenuItem;
    menuItemContextSetLayer: TMenuItem;
    menuItemContextSetLayer9: TMenuItem;
    menuItemContextSetLayer8: TMenuItem;
    menuItemContextSetLayer7: TMenuItem;
    menuItemContextSetLayer6: TMenuItem;
    menuItemContextSetLayer5: TMenuItem;
    menuItemContextSetLayer4: TMenuItem;
    menuItemContextSetLayer3: TMenuItem;
    menuItemContextSetLayer2: TMenuItem;
    menuItemContextSetLayer1: TMenuItem;
    menuItemContextSetLayer0: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure startTimer();
    procedure stopTimer();
    procedure iSettingsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure miNewClick(Sender: TObject);
    procedure miOpenClick(Sender: TObject);
    procedure miSaveClick(Sender: TObject);
    procedure miSaveAsClick(Sender: TObject);
    procedure miModuleClick(Sender: TObject);
    procedure miAboutClick(Sender: TObject);
    procedure miAlwaysFinishFadesClick(Sender: TObject);
    procedure miVisualiseDataFlowClick(Sender: TObject);
    procedure miPauseClick(Sender: TObject);
    procedure tLoadTimer(Sender: TObject);
    procedure miPaintUnpoweredLinesClick(Sender: TObject);
    procedure miPaintHighlightedLinesClick(Sender: TObject);
    procedure aeEventsException(Sender: TObject; E: Exception);
    procedure miLockClick(Sender: TObject);
    procedure miVisualiseShadesClick(Sender: TObject);
    procedure miDisplayValues512Click(Sender: TObject);
    procedure miDisplayValues256Click(Sender: TObject);
    procedure miDisplayValues128Click(Sender: TObject);
    procedure miDisplayValues100Click(Sender: TObject);
    procedure miExitClick(Sender: TObject);
    procedure miSceneNewClick(Sender: TObject);
    procedure miSceneRecallClick(Sender: TObject);
    procedure miSceneStoreClick(Sender: TObject);
    procedure miStatusBarClick(Sender: TObject);
    procedure miProgramManagerClick(Sender: TObject);
    procedure miSceneManagerClick(Sender: TObject);
    procedure menuItemShowLayerClick(Sender: TObject);
    procedure miContextExcludeModuleFromFadeTimeClick(Sender: TObject);
    procedure miContextApplytoAllScenesinCurrentProgramClick(Sender: TObject);
    procedure miContextSetModuleColorClick(Sender: TObject);
    procedure aeEventsMinimize(Sender: TObject);
    procedure aeEventsRestore(Sender: TObject);
    procedure miConfigurationClick(Sender: TObject);
    procedure menuItemSetLayerClick(Sender: TObject);
    procedure miCutClick(Sender: TObject);
    procedure miCopyClick(Sender: TObject);
    procedure miPasteClick(Sender: TObject);
    procedure miDeleteClick(Sender: TObject);
    procedure miBringToFrontClick(Sender: TObject);
    procedure miSendToBackClick(Sender: TObject);
    procedure miSelectAllClick(Sender: TObject);
    procedure miPasteArrayClick(Sender: TObject);
    procedure menuItemOpenFromXMLClick(Sender: TObject);
    procedure menuItemSaveToXMLClick(Sender: TObject);
    procedure menuItemStresstestScreenStickClick(Sender: TObject);
    procedure aeEventsMessage(var Msg: tagMSG; var Handled: Boolean);
    procedure menuItemTraceClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure miToolBarClick(Sender: TObject);
  private
    { Private declarations }
    vistaAltFix: TVistaAltFix;
    iconExists: Boolean;
    hMainIcon: THandle;
    bNotifyIconData: NOTIFYICONDATA;
    procedure initTrayIcon();
    procedure finishTrayIcon();
    procedure addTrayIcon();
    procedure removeTrayIcon();
    procedure updateTitle();
    procedure updateAppearance();
    procedure updateKeys();
    function locateMenuItem(menu: TMenuItem; title: string): TMenuItem;
    function locateMenuItemInsertIndex(menu: TMenuItem; title: string): Integer;
    function locatePopupMenuItem(popupMenu: TPopupMenu; kind: Integer; title: string): TMenuItem;
    function locatePopupMenuItemInsertIndex(popupMenu: TPopupMenu; kind: Integer; title: string): Integer;
    procedure addMainMenuItem(kind, group, title: string);
    procedure addPopupMenuItem(kind, group, title: string);
    procedure loadModules();
    procedure loadComponents();
    procedure loadLUA();
    procedure loadDLOP();
  protected
    procedure WMNOTIFYICON(var Message: TMessage); message WM_NOTIFYICON;
  public
    { Public declarations }
    formDetails: array of TformDetails;
    dvDesktop: TDesktopView;
    currentFile: string;
    programList: TProgramList;
    procedure welcome();
    procedure timerProc();
    procedure closeDetails();
    procedure cleanup();
    procedure new();
    procedure addDesktopFromFile(filename: string);
    procedure open(filename: string);
    procedure saveProgramList(filename: string);
    procedure save(filename: string);
    function saveDialog: Boolean;
    function saveAsDialog: Boolean;
    procedure moduleDelete(m: TModule);
  end;

var
  formLightning:     TformLightning;
  minimized:         Boolean = False;
  externals:         array[0..MAX_MODULES - 1] of TExternal;
  externalsLength:   Integer = 0;
  load:              string = '';
  doNextScene:       Boolean = False;
  nextProgramIndex:  Integer = 1;
  nextProgramAbs:    Boolean = False;
  doNextProgram:     Boolean = False;
  customFadeTime:    Integer = -1;
  useCustomFadeTime: Integer = -1;
  timerThread:       TTimerThread = nil;
  timerStopped:      Integer = 1; // startTimer, stopTimer reference counter
  paintDisabled:     Integer = 0; // enablePaint, disablePaint reference counter

procedure collectDir(path, mask: string; var list: TStringList);
function locateExternal(name: string): PExternal;

// callbacks from modules
procedure openFile(fileName: PChar); cdecl;
procedure nextScene; cdecl;
procedure nextProgram; cdecl;
procedure nextProgramEx(index: Integer; abs: Boolean); cdecl;
procedure setFadeTime(fadeTime: Integer); cdecl;

implementation

uses
  Winsvc, Xdom_3_2,
  usmallport,
  unitformscenemanager, unitformprogrammanager,
  unitformconfiguration, unitformpastearray, unitformabout,
  unitformsplash, unitformtrace;

{$R *.DFM}
{$R ..\RESOURCES\USEDFORSCENE.RES}

function countWindow(window: THandle; className: string): Integer;
var
  bPChar: PChar;
  bWindow: THandle;
begin
  Result := 0;
  GetMem(bPChar, Length(className) + 2);
  try
    bWindow := GetWindow(window, GW_HWNDFIRST);
    while (bWindow <> 0) and (Result < 2) do
    begin
      if GetClassName(bWindow, bPChar, Length(className) + 1) = Length(className) then
      begin
        if bPChar = 'TformLightning' then
          Inc(Result);
      end;
      bWindow := GetWindow(bWindow, GW_HWNDNEXT);
    end;
  finally
    FreeMem(bPChar);
  end;
end;

procedure collectDir(path, mask: string; var list: TStringList);
var
  searchRec:  TSearchRec;
  originalFileName, fileName: string;
begin
  if FindFirst(path + mask, faReadOnly + faHidden + faSysFile + faArchive, searchRec) = 0 then
  begin
    repeat
      originalFileName := searchRec.Name;
      fileName         := path + originalFileName;
      list.Add(fileName);
    until FindNext(searchRec) <> 0;
  end;
  FindClose(searchRec);
end;

function locateExternal(name: string): PExternal;
var
  i: Integer;
begin
  Result := nil;
  i := 0;
  while not((Result <> nil) or (i = externalsLength)) do
  begin
    if externals[i].fileName = name then
      Result := @externals[i];
    Inc(i);
  end;
end;

procedure TformLightning.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  //Color := $00FBFFF8;
  //Color := clWhite;
  //DecimalSeparator := '.';
  vistaAltFix := TVistaAltFix.Create(Self);
  initClipboard();
  currentFile := '';
  programList := nil;
  // TODO use more realistic paths for Windows Vista
{
  odLoad.FileName := ExtractFilePath(ParamStr(0)) + 'desktop\.';
  sdSave.FileName := ExtractFilePath(ParamStr(0)) + 'desktop\.';
  openDialogXML.FileName := ExtractFilePath(ParamStr(0)) + 'desktop\.';
  saveDialogXML.FileName := ExtractFilePath(ParamStr(0)) + 'desktop\.';
}
  SetLength(formDetails, 0);
  dvDesktop := TDesktopView.Create(Self);
  dvDesktop.Parent := Self;
  Inc(externalsLength);
  with externals[externalsLength - 1] do
  begin
    moduleKind  := mkComponentIn;
    fileName    := 'in_component.dll';
    filePath    := '';
    hInstance   := INVALID_HANDLE_VALUE;
  end;
//  addMainMenuItem('I', 'Miscellaneous', 'Component');
//  addPopupMenuItem('I', 'Miscellaneous', 'Component');
  Inc(externalsLength);
  with externals[externalsLength - 1] do
  begin
    moduleKind  := mkComponentOut;
    fileName    := 'out_component.dll';
    filePath    := '';
    hInstance   := INVALID_HANDLE_VALUE;
  end;
//  addMainMenuItem('O', 'Miscellaneous', 'Component');
//  addPopupMenuItem('O', 'Miscellaneous', 'Component');
  loadModules();
  loadComponents();
  loadLUA();
  loadDLOP();
  unitmodulelua.init();
  unitmoduledlop.init();
  ClientWidth := 777;
  miVisualiseDataFlow.OnClick(Sender);
  miVisualiseDataFlow.OnClick(Sender);
  miVisualiseShades.OnClick(Sender);
  miVisualiseShades.OnClick(Sender);
  case lightningSettings.displayValues of
    displayValues512:
    begin
      miDisplayValues512.OnClick(Sender);
      miDisplayValues512.OnClick(Sender);
    end;
    displayValues256:
    begin
      miDisplayValues256.OnClick(Sender);
      miDisplayValues256.OnClick(Sender);
    end;
    displayValues128:
    begin
      miDisplayValues128.OnClick(Sender);
      miDisplayValues128.OnClick(Sender);
    end;
    displayValues100:
    begin
      miDisplayValues100.OnClick(Sender);
      miDisplayValues100.OnClick(Sender);
    end;
  end;
  miPaintUnpoweredLines.OnClick(Sender);
  miPaintUnpoweredLines.OnClick(Sender);
  miPaintHighlightedLines.OnClick(Sender);
  miPaintHighlightedLines.OnClick(Sender);
  miAlwaysFinishFades.OnClick(Sender);
  miAlwaysFinishFades.OnClick(Sender);
  miToolBar.OnClick(Sender);
  miToolBar.OnClick(Sender);
  miStatusBar.OnClick(Sender);
  miStatusBar.OnClick(Sender);
  miLock.OnClick(Sender);
  miLock.OnClick(Sender);
  for i := 0 to 9 do
  begin
    miLayer.Items[i].OnClick(miLayer.Items[i]);
    miLayer.Items[i].OnClick(miLayer.Items[i]);
  end;
  updateAppearance();
  updateKeys();
  // launch Beat Detection if setting is enabled
  if lightningSettings.launchBDetect then
    if FindWindow(nil, 'Beat Detection') = 0 then
      ShellExecute(0, 'open', PChar(ExtractFilePath(ParamStr(0)) + 'bdetect.exe'), '', PChar(ExtractFilePath(ParamStr(0))), SW_SHOWNORMAL);
  // launch DMX Link if setting is enabled
  if lightningSettings.launchDMXLink then
    if FindWindow(nil, 'DMXLink') = 0 then
      ShellExecute(0, 'open', PChar(ExtractFilePath(ParamStr(0)) + 'dmxlink.exe'), '', PChar(ExtractFilePath(ParamStr(0))), SW_SHOWNORMAL);
  Randomize();
  tickInit();
  initTrayIcon();
  startTimer();
end;

procedure TformLightning.FormDestroy(Sender: TObject);
var
  lightningCount: Cardinal;
  window: HWND;
begin
  dvDesktop.Free();
  // count how many Lightning instances are running
  lightningCount := countWindow(Handle, 'TformLightning');
  if lightningSettings.closeDMXLink then
  begin
    window := FindWindow(nil, 'DMXLink');
    if window <> 0 then
      if lightningCount < 2 then
      begin
        // only a single Lightning instance is running,
        // so the DMX Link may be closed
        PostMessage(window, WM_CLOSE, 0, 0);
      end;
  end;
  if lightningSettings.closeBDetect then
  begin
    window := FindWindow(nil, 'Beat Detection');
    if window <> 0 then
      if lightningCount < 2 then
      begin
        // only a single Lightning instance is running,
        // so the DMX Link may be closed
        PostMessage(window, WM_CLOSE, 0, 0);
      end;
  end;
  finishTrayIcon();
  unitmoduledlop.finish();
  unitmodulelua.finish();
  vistaAltFix.Free();
end;

// performs initializations that must be completed after all forms are created
// and the splash screen disappeared.
procedure TformLightning.welcome();
var
  p: Integer;
  paramStartMinimized: Boolean;
  paramFileName: string;
  smallPortStatus: DWORD;
begin
  if not(lightningSettings.smallPortQuery) then
  begin
    with TSmallPort.Create(nil) do
    begin
      smallPortStatus := ServiceStatus();
      Free();
    end;
    if (smallPortStatus = SERVICE_STOPPED) or (smallPortStatus = SERVICE_PAUSED) then
    begin
      // only ask the user this question once
      if MessageBox(
           Handle,
           'The SmallPort driver is required for using some modules, ' +
           'but it isn''t running.'#13#10#13#10 +
           'Would you like to go to the configuration dialog to adjust its settings?',
           PChar(Caption),
           MB_ICONQUESTION or MB_YESNO or MB_DEFBUTTON1
         ) = IDYES then
      begin
        lightningSettings.smallPortQuery := True;
        formConfiguration.pageControlTabs.ActivePage := formConfiguration.tabSheetSmallport;
        miConfigurationClick(Self);
      end;
    end;
  end;
  miProgramManager.Checked   := lightningSettings.programManager;
  formProgramManager.Visible := lightningSettings.programManager;
  miSceneManager.Checked     := lightningSettings.sceneManager;
  formSceneManager.Visible   := lightningSettings.sceneManager;
  // process command-line parameters
  paramStartMinimized := False;
  p := 1;
  while Copy(ParamStr(p), 1, 1) = '/' do
  begin
    if (UpperCase(ParamStr(p)) = '/M') then
      paramStartMinimized := True;
    Inc(p);
  end;
  paramFileName := ParamStr(p);
  if lightningSettings.startMinimized or paramStartMinimized then
    formLightning.WindowState := wsMinimized;
  if paramFileName <> '' then
  begin
    if ExtractFilePath(paramFileName) = '' then
      paramFileName := ExtractFilePath(ParamStr(0)) + paramFileName;
    if FileExists(paramFileName) then
      open(paramFileName)
    else
      new();
  end
  else
    new();
end;

procedure TformLightning.updateTitle();
{
  Pre:  true;
  Post: if a file is currently loaded, the main window's caption contains the filename,
        otherwise the window's title is equal to the default one;
}
begin
  if currentFile <> '' then
    Caption := 'Lightning - ' + ExtractFileName(currentFile)
  else
    Caption := 'Lightning';
end;

procedure TformLightning.updateAppearance();
begin
  if lightningSettings.alwaysOnTop then
    FormStyle := fsStayOnTop
  else
    FormStyle := fsNormal;
  dvDesktop.ShowHint := not(lightningSettings.lock) and lightningSettings.tooltips;
end;

procedure TformLightning.updateKeys();
begin
  if LOBYTE(GetKeyState(VK_SCROLL)) > 0 then
    statusBar.Panels[1].Text := 'SCROLL'
  else
    statusBar.Panels[1].Text := '';
end;

function  TformLightning.locateMenuItem(menu: TMenuItem; title: string): TMenuItem;
var
  i:    Integer;
  item: TMenuItem;
begin
  Result := nil;
  for i := 0 to menu.Count - 1 do
  begin
    item := menu.Items[i];
    if item.Caption = title then
    begin
      Result := item;
      Break;
    end;
  end;
end;

function  TformLightning.locateMenuItemInsertIndex(menu: TMenuItem; title: string): Integer;
var
  i: Integer;
begin
  Result := menu.Count;
  for i := 0 to menu.Count - 1 do
    if CompareText(menu.Items[i].Caption, title) > 0 then
    begin
      Result := i;
      Break;
    end;
end;

function  TformLightning.locatePopupMenuItem(popupMenu: TPopupMenu; kind: Integer; title: string): TMenuItem;
var
  start, ending, i, n: Integer;
  item: TMenuItem;
begin
  n := 0;
  start := 0;
  while n < kind do
  begin
    if popupMenu.Items[start].Caption = '-' then
      Inc(n);
    Inc(start);
  end;
  if kind = 2 then
    ending := popupMenu.Items.Count - 1
  else
  begin
    ending := start;
    while popupMenu.Items[ending].Caption <> '-' do
      Inc(ending);
    Dec(ending);
  end;
  Result := nil;
  for i := start to ending do
  begin
    item := popupMenu.Items[i];
    if item.Caption = title then
    begin
      Result := item;
      Break;
    end;
  end;
end;

function  TformLightning.locatePopupMenuItemInsertIndex(popupMenu: TPopupMenu; kind: Integer; title: string): Integer;
var
  start, ending, i, n: Integer;
begin
  n := 0;
  start := 0;
  while n < kind do
  begin
    if popupMenu.Items[start].Caption = '-' then
      Inc(n);
    Inc(start);
  end;
  ending := start;
  while popupMenu.Items[ending].Caption <> '-' do
    Inc(ending);
  Dec(ending);
  Result := ending + 1;
  for i := start to ending do
    if CompareText(popupMenu.Items[i].Caption, title) > 0 then
    begin
      Result := i;
      Break;
    end;
end;

procedure TformLightning.addMainMenuItem(kind, group, title: string);
var
  menu, menuItem, subMenuItem: TMenuItem;
begin
  case Pos(kind, 'PO') of
    1: menu := miProcess; // P
    2: menu := miOutput;  // O
  else
    menu := miInput; // I
  end;
  menuItem := locateMenuItem(menu, group);
  if menuItem = nil then
  begin
    menuItem := TMenuItem.Create(menu);
    menuItem.Caption := group;
    menu.Insert(locateMenuItemInsertIndex(menu, menuItem.Caption), menuItem);
  end;
  subMenuItem := TMenuItem.Create(menuItem);
  with subMenuItem do
  begin
    Caption := title;
    Tag := Integer(@externals[externalsLength - 1]);
    OnClick := miModuleClick;
  end;
  menuItem.Insert(locateMenuItemInsertIndex(menuItem, subMenuItem.Caption), subMenuItem);
end;

procedure TformLightning.addPopupMenuItem(kind, group, title: string);
var
  kindNumber: Integer;
  menuItem, subMenuItem: TMenuItem;
begin
  case Pos(kind, 'PO') of
    1: kindNumber := 1; // P
    2: kindNumber := 2; // O
  else
    kindNumber := 0; // I
  end;
  menuItem := locatePopupMenuItem(pmPopup, kindNumber, group);
  if menuItem = nil then
  begin
    menuItem := TMenuItem.Create(pmPopup);
    menuItem.Caption := group;
    pmPopup.Items.Insert(locatePopupMenuItemInsertIndex(pmPopup, kindNumber, menuItem.Caption), menuItem);
  end;
  subMenuItem := TMenuItem.Create(menuItem);
  with subMenuItem do
  begin
    Caption := title;
    Tag := Integer(@externals[externalsLength - 1]);
    OnClick := miModuleClick;
  end;
  menuItem.Insert(locateMenuItemInsertIndex(menuItem, subMenuItem.Caption), subMenuItem);
end;

procedure TformLightning.loadModules();
var
  fileList: TStringList;
  i: Integer;
  lib: THandle;
  init: TModuleInit;
  fileName, kind, title, group: string;
begin
  if formSplash <> nil then
  begin
    formSplash.labelModules.Show();
    formSplash.labelModules.Repaint();
  end;
  fileList := TStringList.Create();
  try
    collectDir(ExtractFilePath(ParamStr(0)), '*_*.dll', fileList);
    collectDir(ExtractFilePath(ParamStr(0)) + 'module\', '*_*.dll', fileList);
    if fileList.Count > 0 then
    begin
      for i := 0 to fileList.Count - 1 do
      begin
        fileName := ExtractFileName(fileList[i]);
        if formSplash <> nil then
        begin
          formSplash.labelModulesFile.Caption := fileName + '...';
          formSplash.labelModulesFile.Show();
          formSplash.labelModulesFile.Repaint();
        end;
        lib  := LoadLibrary(PChar(fileList[i]));
        init := GetProcAddress(lib, 'init');
        if @init <> nil then
        begin
          SetLength(group, maxLength);
          SetLength(group, init(PChar(group), Length(group)));
          kind := Copy(group, 1, 1);
          Delete(group, 1, 1);
          parse(group, '|', title);
          if group = '' then
            group := 'Miscellaneous';
          Inc(externalsLength);
          with externals[externalsLength - 1] do
          begin
            moduleKind  := mkNormal;
            fileName    := ExtractFileName(fileList[i]);
            filePath    := ExtractFilePath(fileList[i]);
            hInstance   := lib;
          end;
          if kind <> '' then
          begin
            addMainMenuItem(kind, group, title);
            addPopupMenuItem(kind, group, title);
          end;
        end;
      end;
    end;
    miInput.Visible := miInput.Count > 0;
    miProcess.Visible := miProcess.Count > 0;
    miOutput.Visible := miOutput.Count > 0;
  finally
    fileList.Free();
  end;
  if formSplash <> nil then
  begin
    formSplash.labelModulesFile.Caption := 'done.';
    formSplash.labelModulesFile.Show();
    formSplash.labelModulesFile.Repaint();
  end;
end;

procedure TformLightning.loadComponents();
var
  fileList: TStringList;
  i: Integer;
  fileName, title: string;
  menuItem: TMenuItem;
begin
  if formSplash <> nil then
  begin
    formSplash.labelComponents.Show();
    formSplash.labelComponents.Repaint();
  end;
  fileList := TStringList.Create();
  try
    collectDir(ExtractFilePath(ParamStr(0)) + 'component\', '*.lig', fileList);
    collectDir(ExtractFilePath(ParamStr(0)) + 'component\', '*.xml', fileList);
    if fileList.Count > 0 then
    begin
      for i := 0 to fileList.Count - 1 do
      begin
        fileName := ExtractFileName(fileList[i]);
        if formSplash <> nil then
        begin
          formSplash.labelComponentsFile.Caption := fileName + '...';
          formSplash.labelComponentsFile.Show();
          formSplash.labelComponentsFile.Repaint();
        end;
        title := fileName;
        Inc(externalsLength);
        with externals[externalsLength - 1] do
        begin
          moduleKind  := mkComponent;
          fileName    := ExtractFileName(fileList[i]);
          filePath    := ExtractFilePath(fileList[i]);
          hInstance   := 0;
        end;
        menuItem := locateMenuItem(miComponents, title);
        if menuItem = nil then
        begin
          menuItem := TMenuItem.Create(miComponents);
          with menuItem do
          begin
            Caption := title;
            Tag := Integer(@externals[externalsLength - 1]);
            OnClick := miModuleClick;
          end;
          miComponents.Add(menuItem);
        end;
        menuItem := TMenuItem.Create(miPopupComponents);
        with menuItem do
        begin
          Caption := title;
          Tag := Integer(@externals[externalsLength - 1]);
          OnClick := miModuleClick;
        end;
        miPopupComponents.Add(menuItem);
      end;
    end;
    miComponents.Visible := miComponents.Count > 0;
    miPopupComponents.Visible := miPopupComponents.Count > 0;
  finally
    fileList.Free();
  end;
  if formSplash <> nil then
  begin
    formSplash.labelComponentsFile.Caption := 'done.';
    formSplash.labelComponentsFile.Show();
    formSplash.labelComponentsFile.Repaint();
  end;
end;

procedure TformLightning.loadLUA();
var
  fileList: TStringList;
  i: Integer;
  fileName, title: string;
  menuItem: TMenuItem;
begin
  if formSplash <> nil then
  begin
    formSplash.labelLUA.Show();
    formSplash.labelLUA.Repaint();
  end;
  fileList := TStringList.Create();
  try
    collectDir(ExtractFilePath(ParamStr(0)), '*.lua', fileList);
    collectDir(ExtractFilePath(ParamStr(0)) + 'lua\', '*.lua', fileList);
    if fileList.Count > 0 then
    begin
      for i := 0 to fileList.Count - 1 do
      begin
        fileName := ExtractFileName(fileList[i]);
        if formSplash <> nil then
        begin
          formSplash.labelLUAFile.Caption := fileName + '...';
          formSplash.labelLUAFile.Show();
          formSplash.labelLUAFile.Repaint();
        end;
        title := fileName;
        Inc(externalsLength);
        with externals[externalsLength - 1] do
        begin
          moduleKind  := mkLUA;
          fileName    := ExtractFileName(fileList[i]);
          filePath    := ExtractFilePath(fileList[i]);
          hInstance   := 0;
        end;
        menuItem := locateMenuItem(miLUA, title);
        if menuItem = nil then
        begin
          menuItem := TMenuItem.Create(miLUA);
          with menuItem do
          begin
            Caption := title;
            Tag := Integer(@externals[externalsLength - 1]);
            OnClick := miModuleClick;
          end;
          miLUA.Add(menuItem);
        end;
        menuItem := TMenuItem.Create(miPopupLUA);
        with menuItem do
        begin
          Caption := title;
          Tag := Integer(@externals[externalsLength - 1]);
          OnClick := miModuleClick;
        end;
        miPopupLUA.Add(menuItem);
      end;
    end;
    miLUA.Visible := miLUA.Count > 0;
    miPopupLUA.Visible := miPopupLUA.Count > 0;
  finally
    fileList.Free();
  end;
  if formSplash <> nil then
  begin
    formSplash.labelLUAFile.Caption := 'done.';
    formSplash.labelLUAFile.Show();
    formSplash.labelLUAFile.Repaint();
  end;
end;

procedure TformLightning.loadDLOP();
var
  fileList: TStringList;
  i: Integer;
  lib: THandle;
  dlo_getName: TDLOGetName;
  fileName, title: string;
  menuItem: TMenuItem;
begin
  if formSplash <> nil then
  begin
    formSplash.labelDLOP.Show();
    formSplash.labelDLOP.Repaint();
  end;
  fileList := TStringList.Create();
  try
    collectDir(ExtractFilePath(ParamStr(0)), '*.dll', fileList);
    collectDir(ExtractFilePath(ParamStr(0)) + 'dlop\', '*.dll', fileList);
    if fileList.Count > 0 then
    begin
      for i := 0 to fileList.Count - 1 do
      begin
        fileName := ExtractFileName(fileList[i]);
        if (fileName <> 'bass.dll') and (fileName <> 'lua.dll') and (fileName <> 'lualib.dll') then
        begin
          if formSplash <> nil then
          begin
            formSplash.labelDLOPFile.Caption := fileName + '...';
            formSplash.labelDLOPFile.Show();
            formSplash.labelDLOPFile.Repaint();
          end;
          lib := LoadLibrary(PChar(fileList[i]));
          if lib <> INVALID_HANDLE_VALUE then
          begin
            dlo_getName := GetProcAddress(lib, 'DLO_getname');
            FreeLibrary(lib);
            // check if this really is a DLOP
            if @dlo_getName <> nil then
            begin
              title := ExtractFileName(fileList[i]);//dlo_getName;
              Inc(externalsLength);
              with externals[externalsLength - 1] do
              begin
                moduleKind  := mkDLOP;
                fileName    := ExtractFileName(fileList[i]);
                filePath    := ExtractFilePath(fileList[i]);
                hInstance   := 0;
              end;
              menuItem := locateMenuItem(miDLOP, title);
              if menuItem = nil then
              begin
                menuItem := TMenuItem.Create(miDLOP);
                with menuItem do
                begin
                  Caption := title;
                  Tag := Integer(@externals[externalsLength - 1]);
                  OnClick := miModuleClick;
                end;
                miDLOP.Add(menuItem);
              end;
              menuItem := TMenuItem.Create(miPopupDLOP);
              with menuItem do
              begin
                Caption := title;
                Tag := Integer(@externals[externalsLength - 1]);
                OnClick := miModuleClick;
              end;
              miPopupDLOP.Add(menuItem);
            end;
          end;
        end;
      end;
    end;
    miDLOP.Visible := miDLOP.Count > 0;
    miPopupDLOP.Visible := miPopupDLOP.Count > 0;
  finally
    fileList.Free();
  end;
  if formSplash <> nil then
  begin
    formSplash.labelDLOPFile.Caption := 'done.';
    formSplash.labelDLOPFile.Show();
    formSplash.labelDLOPFile.Repaint();
  end;
end;

procedure TformLightning.FormClose(Sender: TObject; var Action: TCloseAction);
var
  i: Integer;
  finish: TModuleFinish;
begin
  stopTimer();
  dvDesktop.disablePaint();
  cleanup();
  for i := 0 to externalsLength - 1 do
  begin
    if externals[i].hInstance <> 0 then
    begin
      @finish := GetProcAddress(externals[i].hInstance, 'finish');
      if @finish <> nil then
        finish();
      FreeLibrary(externals[i].hInstance);
    end;
  end;
end;

procedure TformLightning.initTrayIcon();
begin
  iconExists := False;
  hMainIcon := LoadIcon(hInstance, 'MAINICON');
  with bNotifyIconData do
  begin
    cbSize              := SizeOf(bNotifyIconData);
    Wnd                 := Handle;
    uID                 := 0;
    uFlags              := NIF_ICON or NIF_MESSAGE or NIF_TIP;
    uCallbackMessage    := WM_NOTIFYICON;
    hIcon               := hMainIcon;
    StrPCopy(szTip, Application.Title);
  end;
end;

procedure TformLightning.finishTrayIcon();
begin
  RemoveTrayIcon();
end;

procedure TformLightning.addTrayIcon();
begin
  if not(iconExists) then
  begin
    Shell_NotifyIcon(NIM_ADD, @bNotifyIconData);
    iconExists := True;
  end;
end;

procedure TformLightning.removeTrayIcon();
begin
  if iconExists then
  begin
    Shell_NotifyIcon(NIM_DELETE, @bNotifyIconData);
    iconExists := False;
  end;
end;

procedure TformLightning.startTimer();
begin
  if timerStopped > 0 then
  begin
    Dec(timerStopped);
    if timerStopped = 0 then
      if (timerThread = nil) and not(miPause.Checked) then
      begin
        timerThread := TTimerThread.Create(True, lightningSettings.interval);
        timerThread.FreeOnTerminate := False;
        timerThread.Resume();
      end;
  end;
end;

procedure TformLightning.stopTimer();
begin
  if timerStopped = 0 then
  begin
    if timerThread <> nil then
    begin
      timerThread.Terminate();
      timerThread.WaitFor();
      timerThread.Free();
      timerThread := nil;
    end;
  end;
  Inc(timerStopped);
end;

procedure TformLightning.iSettingsMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  module: TModule;
  i: Integer;
  form: TformDetails;
begin
  // on click on a module's '...' button, display appropriate settings window
  module := TModule(TControl(Sender).Parent);
  form := nil;
  // check if a details form already exists for this module, if so, reuse it
  for i := 0 to Length(formDetails) - 1 do
  begin
    if formDetails[i].module = module then
    begin
      form := formDetails[i];
      form.module.hide(form.module.module);
      Break;
    end;
  end;
  if form = nil then
  begin
    // try to find an existing details form that can be reused
    for i := 0 to Length(formDetails) - 1 do
    begin
      if formDetails[i].speedButtonPin.Tag = 0 then
      begin
        form := formDetails[i];
        form.module.hide(form.module.module);
        Break;
      end;
    end;
    // if no existing details form can be reused, create a new one
    if form = nil then
    begin
      SetLength(formDetails, Length(formDetails) + 1);
      form := TformDetails.Create(Self);
      formDetails[Length(formDetails) - 1] := form;
    end;
  end;
  form.module := module;
  form.module.show(form.module.module, form.Handle);
  if form.module.kind = mkDLOP then
  begin
    form.Visible := False;
  end
  else
  begin
    form.Visible := True;
    form.BringToFront();
  end;
end;

procedure TformLightning.timerProc();
begin
  customFadeTime := -1;
  dvDesktop.moduleAction();
  // check advance time and if neccesary advance scene
  if formSceneManager.decrementAdvanceTime() then
    nextScene();
  if doNextScene then
  begin
    doNextScene := False;
    formSceneManager.nextScene();
  end;
  {if doNextProgram and not(fProgramManager.chNoProgramSwitch.Checked) then
  begin
    doNextProgram := False;
    if programList.Count > 0 then
      if currentProgram < programList.Count - 1 then
        fProgramManager.switchProgram(currentProgram + 1, True)
      else
        fProgramManager.switchProgram(0, True);
  end;}
  if doNextProgram or (load <> '') then
  begin
    // delayed loading of a new desktop
    tLoad.Interval := lightningSettings.interval;
    tLoad.Enabled  := True;
  end;
  if customFadeTime <> useCustomFadeTime then
    useCustomFadeTime := customFadeTime;
end;

// closes all details windows
procedure TformLightning.closeDetails();
var
  detailsModule: TModule;
begin
  while Length(formDetails) > 0 do
  begin
    detailsModule := formDetails[0].module;
    detailsModule.closeDetails(True);
  end;
end;

procedure TformLightning.cleanup();
begin
  stopTimer();
  try
    dvDesktop.disablePaint();
    try
      formSceneManager.cleanup();
      if programList <> nil then
      begin
        programList.Free();
        programList := nil;
      end;
      dvDesktop.clear();
      currentFile := '';
      updateTitle();
    finally
      dvDesktop.enablePaint();
    end;
  finally
    startTimer();
  end;
end;

procedure TformLightning.new();
begin
  stopTimer();
  try
    dvDesktop.disablePaint();
    try
      cleanup();
      programList := TProgramList.Create();
      programList.Add('0');
      formProgramManager.lbPrograms.Clear;
      formProgramManager.lbPrograms.Items.Add('Program');
      currentProgramIndex := 0;
      currentProgramName  := 'Program';
      if not(formProgramManager.chOverride.Checked) then
        formProgramManager.upDownFadeTime.Position := 0;
      if not(formSceneManager.chOverride.Checked) then
        formSceneManager.upDownFadeTime.Position := 0;
    finally
      dvDesktop.enablePaint();
    end;
  finally
    startTimer();
  end;
end;

procedure TformLightning.addDesktopFromFile(filename: string);
var
  i: Integer;
  name, line: string;
begin
  name := ChangeFileExt(filename, '.lld');
  if FileExists(name) then
  begin
    formProgramManager.lbPrograms.Clear;
    programList.LoadFromFile(name);
    if programList.Count > 1 then
    begin
      programList.Delete(0);
      for i := 0 to programList.Count - 1 do // fill up list with numbers of program files
      begin
        try
          with TStringList.Create() do
          begin
            // open each file in order to retrieve its name
            LoadFromFile(formProgramManager.indexToFileName(currentFile, i));
            if Count > 0 then
            begin
              line := Strings[0];
              formProgramManager.lbPrograms.Items.Add(parse(line, '|'));
            end;
            Free();
          end;
        except
          on EConvertError do;
        end;
      end;
      formProgramManager.loadProgram(0);
    end;
    // else INVALID DESKTOP FILE --> SHOW ERROR
    //   // no programs present --> create default program
  end;
  //else MUST BE PREINITIALIZED BY NEW OR CREATE DEFAULT PROGRAM
    //programList.Clear;
    //fProgramManager.lbPrograms.Clear;
end;

procedure TformLightning.open(filename: string);
begin
  stopTimer();
  try
    dvDesktop.disablePaint();
    try
      new();
      currentFile := filename;
      updateTitle();
      dvDesktop.fromStringFile(filename);
      addDesktopFromFile(filename);
    finally
      dvDesktop.enablePaint();
    end;
  finally
    startTimer();
  end;
end;

procedure TformLightning.saveProgramList(filename: string);
begin
  // NEEDS REVIEWING!!!
  programList.Insert(0, ''); // temporarily add dummy line for future use
  programList.SaveToFile(ChangeFileExt(filename, '.lld'));
  programList.Delete(0);
end;

procedure TformLightning.save(fileName: string);
var
  i: Integer;
begin
  // scroll bars must be set to zero to ensure that all original control
  // positions will be saved.
  dvDesktop.HorzScrollBar.Position := 0;
  dvDesktop.VertScrollBar.Position := 0;
  if (currentFile <> '') and (filename <> currentFile) then
  begin
    // if the desktop file name changed,
    // copy all programs to the new location on disk.
    for i := 0 to programList.Count - 1 do
    begin
      //desktop
      CopyFile(
        PChar(formProgramManager.indexToFileName(currentFile, i)),
        PChar(formProgramManager.indexToFileName(filename, i)),
        False
      );
    end;
  end;
  currentFile := fileName;
  updateTitle();
  // save any changes to the current program to disk.
  formSceneManager.saveProgram(
    formProgramManager.indexToFileName(currentFile, currentProgramIndex),
    currentProgramName
  );
  dvDesktop.toStringFile(fileName);
  // save any changes to the list of program numbers.
  saveProgramList(fileName);
end;

function  TformLightning.saveDialog(): Boolean;
begin
  // hide details window prior to showing dialog
  closeDetails();
  if currentFile = '' then
    Result := saveAsDialog()
  else
  begin
    Result := True;
    save(currentFile);
  end;
end;

function  TformLightning.saveAsDialog(): Boolean;
begin
  // hide details window prior to showing dialog
  closeDetails();
  if sdSave.Execute() then
  begin
    odLoad.FileName := ExtractFilePath(sdSave.FileName) + '.';
    save(sdSave.FileName);
    Result := True;
  end
  else
    Result := False;
end;

procedure TformLightning.miNewClick(Sender: TObject);
begin
  new();
end;

procedure TformLightning.miOpenClick(Sender: TObject);
begin
  // hide details window prior to showing dialog
  closeDetails();
  if odLoad.Execute() then
  begin
    sdSave.FileName := ExtractFilePath(odLoad.FileName) + '.';
    open(odLoad.FileName);
  end;
end;

procedure TformLightning.miSaveClick(Sender: TObject);
begin
  saveDialog();
end;

procedure TformLightning.miSaveAsClick(Sender: TObject);
begin
  saveAsDialog();
end;

procedure TformLightning.miModuleClick(Sender: TObject);
var
  popupClick: Boolean;
  top, left: Integer;
begin
  popupClick :=
    (TMenuItem(Sender).Parent.Owner is TPopupMenu) // normal module selected from popup
    or
    ( // component/DLOP/LUA module selected from popup
      (TMenuItem(Sender).Parent.Parent <> nil)
      and
      (TMenuItem(Sender).Parent.Parent.Owner is TPopupMenu)
    );
  if popupClick then
  begin
    top := dvDesktop.popup.Y;
    left := dvDesktop.popup.X;
  end
  else
  begin
    top := defaultTop;
    left := defaultLeft;
  end;
  with TModule.createNew(dvDesktop, top, left, PExternal(TMenuItem(Sender).Tag)^.fileName, dvDesktop.generateSceneid(), popupClick) do
  begin
    if not(popupClick) then
    begin
      if kind = mkDLOP then
        // guard against unwanted effects resulting from DLOP startup dialog windows
        formLightning.BringToFront();
      dvDesktop.deltaX := 0;
      dvDesktop.deltaY := 0;
      BeginDrag(True);
    end;
  end;
end;

procedure TformLightning.miAboutClick(Sender: TObject);
begin
  formAbout.ShowModal();
end;

procedure TformLightning.miAlwaysFinishFadesClick(Sender: TObject);
begin
  lightningSettings.alwaysFinishFades := not(lightningSettings.alwaysFinishFades);
  miAlwaysFinishFades.Checked := lightningSettings.alwaysFinishFades;
end;

procedure TformLightning.miVisualiseDataFlowClick(Sender: TObject);
begin
  lightningSettings.visualiseDataFlow := not(lightningSettings.visualiseDataFlow);
  miVisualiseDataFlow.Checked  := lightningSettings.visualiseDataFlow;
  miVisualiseShades.Enabled    := lightningSettings.visualiseDataFlow;
  miDisplayValues512.Enabled   := lightningSettings.visualiseDataFlow;
  miDisplayValues256.Enabled   := lightningSettings.visualiseDataFlow;
  miDisplayValues128.Enabled   := lightningSettings.visualiseDataFlow;
  miDisplayValues100.Enabled   := lightningSettings.visualiseDataFlow;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miVisualiseShadesClick(Sender: TObject);
begin
  lightningSettings.visualiseShades := not(lightningSettings.visualiseShades);
  miVisualiseShades.Checked := lightningSettings.visualiseShades;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miDisplayValues512Click(Sender: TObject);
begin
  if lightningSettings.displayValues = displayValues512 then
    lightningSettings.displayValues := displayValuesNone
  else
    lightningSettings.displayValues := displayValues512;
  miDisplayValues512.Checked := lightningSettings.displayValues = displayValues512;
  miDisplayValues256.Checked := lightningSettings.displayValues = displayValues256;
  miDisplayValues128.Checked := lightningSettings.displayValues = displayValues128;
  miDisplayValues100.Checked := lightningSettings.displayValues = displayValues100;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miDisplayValues256Click(Sender: TObject);
begin
  if lightningSettings.displayValues = displayValues256 then
    lightningSettings.displayValues := displayValuesNone
  else
    lightningSettings.displayValues := displayValues256;
  miDisplayValues512.Checked := lightningSettings.displayValues = displayValues512;
  miDisplayValues256.Checked := lightningSettings.displayValues = displayValues256;
  miDisplayValues128.Checked := lightningSettings.displayValues = displayValues128;
  miDisplayValues100.Checked := lightningSettings.displayValues = displayValues100;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miDisplayValues128Click(Sender: TObject);
begin
  if lightningSettings.displayValues = displayValues128 then
    lightningSettings.displayValues := displayValuesNone
  else
    lightningSettings.displayValues := displayValues128;
  miDisplayValues512.Checked := lightningSettings.displayValues = displayValues512;
  miDisplayValues256.Checked := lightningSettings.displayValues = displayValues256;
  miDisplayValues128.Checked := lightningSettings.displayValues = displayValues128;
  miDisplayValues100.Checked := lightningSettings.displayValues = displayValues100;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miDisplayValues100Click(Sender: TObject);
begin
  if lightningSettings.displayValues = displayValues100 then
    lightningSettings.displayValues := displayValuesNone
  else
    lightningSettings.displayValues := displayValues100;
  miDisplayValues512.Checked := lightningSettings.displayValues = displayValues512;
  miDisplayValues256.Checked := lightningSettings.displayValues = displayValues256;
  miDisplayValues128.Checked := lightningSettings.displayValues = displayValues128;
  miDisplayValues100.Checked := lightningSettings.displayValues = displayValues100;
  dvDesktop.updateConnectors();
end;

procedure TformLightning.miPauseClick(Sender: TObject);
begin
  miPause.Checked := not(miPause.Checked);
  if miPause.Checked then
    stopTimer()
  else
    startTimer();
end;

// start of callbacks for normal modules

procedure openFile(fileName: PChar); cdecl;
begin
  load := fileName;
end;

procedure nextScene(); cdecl;
begin
  doNextScene := True;
end;

procedure nextProgram(); cdecl;
begin
  nextProgramIndex := 1;
  nextProgramAbs   := False;
  doNextProgram    := True;
end;

procedure nextProgramEx(index: Integer; abs: Boolean); cdecl;
begin
  nextProgramIndex := index;
  nextProgramAbs   := abs;
  doNextProgram    := True;
end;

procedure setFadeTime(fadeTime: Integer); cdecl;
begin
  customFadeTime := fadeTime;
end;

// end of callbacks for normal modules

procedure TformLightning.tLoadTimer(Sender: TObject);
var
  bString: string;
  index: Integer;
begin
  tLoad.Enabled := False;
  if doNextProgram then
  begin
    doNextProgram := False;
    if not(formProgramManager.chNoProgramSwitch.Checked) then
      if programList.Count > 0 then
      begin
        if nextProgramAbs then
          index := nextProgramIndex
        else
          index := currentProgramIndex + nextProgramIndex;
        while (index < 0) do
          index := programList.Count + index;
        while (index >= programList.Count) do
          index := index - programList.Count;
        formProgramManager.switchProgram(index, True)
        {if currentProgram < programList.Count - 1 then
          fProgramManager.switchProgram(currentProgram + 1, True)
        else
          fProgramManager.switchProgram(0, True);}
      end;
  end
  else
  begin
    bString := load;
    load    := '';
    if FileExists(bString) then
      open(bString);
  end;
end;

procedure TformLightning.miPaintUnpoweredLinesClick(Sender: TObject);
begin
  lightningSettings.paintUnpoweredLines := not(lightningSettings.paintUnpoweredLines);
  miPaintUnpoweredLines.Checked := lightningSettings.paintUnpoweredLines;
  dvDesktop.Repaint();
end;

procedure TformLightning.miPaintHighlightedLinesClick(Sender: TObject);
begin
  lightningSettings.paintHighlightedLines := not(lightningSettings.paintHighlightedLines);
  miPaintHighlightedLines.Checked := lightningSettings.paintHighlightedLines;
  dvDesktop.Repaint();
end;

procedure TformLightning.aeEventsException(Sender: TObject; E: Exception);
begin
  // ignore EInvalidOperation exception to prevent error:
  // "Control has no Parent window"
  if not(E is EInvalidOperation) then
  begin
    if not(lightningSettings.statusBar) then
      miStatusBarClick(Sender);
    statusBar.Panels[0].Text := E.ClassName + ': ' + E.Message;
  end;
end;

procedure TformLightning.miLockClick(Sender: TObject);
begin
  lightningSettings.lock := not(lightningSettings.lock);
  miLock.Checked         := lightningSettings.lock;
  miEdit.Visible         := not(lightningSettings.lock);
  miLayer.Visible        := not(lightningSettings.lock);
  miInput.Visible        := not(lightningSettings.lock) and (miInput.Count > 0);
  miProcess.Visible      := not(lightningSettings.lock) and (miProcess.Count > 0);
  miOutput.Visible       := not(lightningSettings.lock) and (miOutput.Count > 0);
  miDLOP.Visible         := not(lightningSettings.lock) and (miDLOP.Count > 0);
  miLUA.Visible          := not(lightningSettings.lock) and (miLUA.Count > 0);
  miComponents.Visible   := not(lightningSettings.lock) and (miComponents.Count > 0);
  dvDesktop.ShowHint     := not(lightningSettings.lock) and lightningSettings.tooltips;
  dvDesktop.updateLocked();
  updateAppearance();
end;

procedure TformLightning.miExitClick(Sender: TObject);
begin
  Close();
end;

procedure TformLightning.miSceneNewClick(Sender: TObject);
begin
  formSceneManager.tbNewClick(miSceneNew);
end;

procedure TformLightning.miSceneRecallClick(Sender: TObject);
begin
  formSceneManager.tbRecallClick(miSceneRecall);
end;

procedure TformLightning.miSceneStoreClick(Sender: TObject);
begin
  formSceneManager.tbStoreClick(miSceneStore);
end;

procedure TformLightning.miStatusBarClick(Sender: TObject);
begin
  lightningSettings.statusBar := not(lightningSettings.statusBar);
  miStatusBar.Checked := lightningSettings.statusBar;
  statusBar.Visible := miStatusBar.Checked;
end;

procedure TformLightning.miProgramManagerClick(Sender: TObject);
begin
  lightningSettings.programManager := not(lightningSettings.programManager);
  miProgramManager.Checked := lightningSettings.programManager;
  formProgramManager.Visible := lightningSettings.programManager;
end;

procedure TformLightning.miSceneManagerClick(Sender: TObject);
begin
  lightningSettings.sceneManager := not(lightningSettings.sceneManager);
  miSceneManager.Checked := lightningSettings.sceneManager;
  formSceneManager.Visible := lightningSettings.sceneManager;
end;

procedure TformLightning.menuItemShowLayerClick(Sender: TObject);
var
  menuItem: TMenuItem;
begin
  menuItem := TMenuItem(Sender);
  lightningSettings.showLayer[menuItem.Tag] := not(lightningSettings.showLayer[menuItem.Tag]);
  menuItem.Checked := lightningSettings.showLayer[menuItem.Tag];
  dvDesktop.updateLayers();
end;

procedure TformLightning.miContextExcludeModuleFromFadeTimeClick(Sender: TObject);
begin
  if dvDesktop.contextModule <> nil then
  begin
    dvDesktop.contextModule.excludeFromFadeTime := not(dvDesktop.contextModule.excludeFromFadeTime);
    miContextExcludeModuleFromFadeTime.Checked := dvDesktop.contextModule.excludeFromFadeTime;
  end;
end;

procedure TformLightning.miContextApplytoAllScenesinCurrentProgramClick(
  Sender: TObject);
var
  i, j: Integer;
  bPScene: PScene;
  settings: string;
begin
  if dvDesktop.contextModule <> nil then
  begin
    formLightning.stopTimer();
    try
      SetLength(settings, maxLength);
      SetLength(settings, dvDesktop.contextModule.savescene(dvDesktop.contextModule.module, PChar(settings), Length(settings)));
      for i := 0 to bProgram.Count - 1 do
      begin
        bPScene := PScene(bProgram[i]);
        j := bPScene^.itemIndex.IndexOf(dvDesktop.contextModule.sceneid);
        bPScene^.itemData[j] := settings;
      end;
    finally
      formLightning.startTimer();
    end;
  end;
end;

procedure TformLightning.miContextSetModuleColorClick(Sender: TObject);
begin
  with TColorDialog.Create(Self) do
    try
      Color := dvDesktop.selectedModulesGetColor();
      CustomColors.Add('ColorA=' + IntToHex(ColorToRGB(clBtnFace), 6));
      if Execute() then
        dvDesktop.selectedModulesSetColor(color);
    finally
      Free();
    end;
end;

procedure TformLightning.WMNOTIFYICON(var Message: TMessage);
begin
  if Message.lParam = WM_LBUTTONUP then
  begin
    Application.Restore();
    Application.BringToFront();
    SetFocus();
  end;
end;

procedure TformLightning.aeEventsMinimize(Sender: TObject);
begin
  minimized := True;
  if lightningSettings.systemTray then
  begin
    ShowWindow(Application.Handle, SW_HIDE);
    Hide();
    AddTrayIcon();
  end;
end;

procedure TformLightning.aeEventsRestore(Sender: TObject);
begin
  if iconExists then
  begin
    RemoveTrayIcon();
    Show();
  end;
  minimized := False;
end;

procedure TformLightning.miConfigurationClick(Sender: TObject);
begin
  with formConfiguration do
  begin
    setTimerProcessing(lightningSettings.interval);
    setTimerGraphics(lightningSettings.intervalGraphics);
    checkBoxLaunchBDetect.Checked    := lightningSettings.launchBDetect;
    checkBoxCloseBDetect.Checked     := lightningSettings.closeBDetect;
    checkBoxLaunchDMXLink.Checked    := lightningSettings.launchDMXLink;
    checkBoxCloseDMXLink.Checked     := lightningSettings.closeDMXLink;
    checkBoxSplash.Checked           := lightningSettings.splash;
    checkBoxStartMinimized.Checked   := lightningSettings.startMinimized;
    checkBoxSystemTray.Checked       := lightningSettings.systemTray;
    checkBoxAlwaysOnTop.Checked      := lightningSettings.alwaysOnTop;
    checkBoxTooltips.Checked         := lightningSettings.tooltips;
    if ShowModal() = mrOK then
    begin
      lightningSettings.launchBDetect  := checkBoxLaunchBDetect.Checked;
      lightningSettings.closeBDetect   := checkBoxCloseBDetect.Checked;
      lightningSettings.launchDMXLink  := checkBoxLaunchDMXLink.Checked;
      lightningSettings.closeDMXLink   := checkBoxCloseDMXLink.Checked;
      lightningSettings.splash         := checkBoxSplash.Checked;
      lightningSettings.startMinimized := checkBoxStartMinimized.Checked;
      lightningSettings.systemTray     := checkBoxSystemTray.Checked;
      lightningSettings.alwaysOnTop    := checkBoxAlwaysOnTop.Checked;
      lightningSettings.tooltips       := checkBoxTooltips.Checked;
      // restart timer to use new intervals
      stopTimer();
      lightningSettings.interval := getTimerProcessing();
      lightningSettings.intervalGraphics := getTimerGraphics();
      startTimer();
      updateAppearance();
    end;
  end;
end;

procedure TformLightning.moduleDelete(m: TModule);
var
  bString, fileName: string;
  programModified: Boolean;
  i, index: Integer;
begin
  stopTimer();
  try
    dvDesktop.disablePaint();
    try
      if @m.openscene <> nil then
      begin
        // if the module is scene compatible,
        // the module can only be deleted from the desktop,
        // when it is no longer referenced to in any programs.
        // remove module's sceneid from all scenes in current program.
        programModified := False;
        for i := 0 to bProgram.Count - 1 do
        begin
          index := PScene(bProgram[i])^.itemIndex.IndexOf(m.sceneid);
          if index > -1 then
          begin
            // only remove the module's sceneid from the program if it is actually present.
            programModified := True;
            PScene(bProgram[i])^.itemIndex.Delete(index);
            PScene(bProgram[i])^.itemData.Delete(index);
          end;
        end;
        if programModified then
        begin
          // only save the changes to current program, if it has changed.
          formSceneManager.saveProgram(
            formProgramManager.indexToFileName(currentFile, currentProgramIndex),
            currentProgramName
          );
        end;
        // remove sceneid from all scenes in other programs
        if programList.Count > 1 then
          for index := 0 to programList.Count - 1 do
          begin
            if index <> currentProgramIndex then
              with TStringList.Create() do
                try
                  fileName := formProgramManager.indexToFileName(currentFile, index);
                  LoadFromFile(fileName);
                  programModified := False;
                  if Count > 0 then
                  begin
                    i := 1; // skip program information
                    while i < Count do
                    begin
                      if Strings[i] <> '' then
                      begin
                        Inc(i); // skip scene information
                        while Strings[i] <> '' do
                        begin
                          bString := Strings[i];
                          if parse(bString, '|') = m.sceneid then
                          begin
                            programModified := True;
                            Delete(i);
                          end
                          else
                            Inc(i);
                        end;
                      end;
                      Inc(i);
                    end;
                  end;
                  // only save changes to the program, if it has changed
                  if programModified then
                    SaveToFile(fileName);
                finally
                  Free();
                end;
          end;
      end;
      m.Free();
    finally
      dvDesktop.enablePaint();
    end;
  finally
    startTimer();
  end;
end;

procedure TformLightning.menuItemSetLayerClick(Sender: TObject);
begin
  dvDesktop.selectedModulesSetLayer(TMenuItem(Sender).Tag);
end;

procedure TformLightning.miCutClick(Sender: TObject);
begin
  if not(lightningSettings.lock)
     and
     (
       MessageBox(
         Handle,
         'Although the modules and connections could be recovered '#13#10 +
         'using the clipboard, this may delete the scene data.'#13#10 +
         'All programs will also be saved.'#13#10 +
         'Are you sure?',
         'Confirmation',
         MB_ICONQUESTION or MB_YESNO
       ) = IDYES
     ) then
  begin
    dvDesktop.selectedModulesCut();
  end;
end;

procedure TformLightning.miCopyClick(Sender: TObject);
begin
  if not(lightningSettings.lock) then
  begin
    dvDesktop.selectedModulesCopy();
  end;
end;

procedure TformLightning.miPasteClick(Sender: TObject);
begin
  if not(lightningSettings.lock) then
  begin
    dvDesktop.allModulesSetIsSelected(False);
    dvDesktop.paste(0, 0);
    if Length(dvDesktop.selectedModules) > 0 then
    begin
      dvDesktop.deltaX := 0;
      dvDesktop.deltaY := 0;
      dvDesktop.selectedModulesSetVisible(False);
      dvDesktop.selectedModules[0].BeginDrag(True);
    end;
  end;
end;

procedure TformLightning.miDeleteClick(Sender: TObject);
begin
  if not(lightningSettings.lock) then
     if MessageBox(
       Handle,
       'This will permanently delete all selected modules.'#13#10 +
       'All programs will also be saved.'#13#10 +
       'Are you sure?',
       'Confirmation',
       MB_ICONQUESTION or MB_YESNO
     ) = IDYES then
  begin
    dvDesktop.selectedModulesDelete();
  end;
end;

procedure TformLightning.miBringToFrontClick(Sender: TObject);
begin
  dvDesktop.selectedModulesBringToFront();
end;

procedure TformLightning.miSendToBackClick(Sender: TObject);
begin
  dvDesktop.selectedModulesSendToBack();
end;

procedure TformLightning.miSelectAllClick(Sender: TObject);
begin
  dvDesktop.allModulesSetIsSelected(True);
end;

procedure TformLightning.miPasteArrayClick(Sender: TObject);
var
  top, left, width, height, i: Integer;
  modalResult: TModalResult;
begin
  if not(lightningSettings.lock) then
  begin
    modalResult := formPasteArray.ShowModal();
    if (modalResult = mrYes) or (modalResult = mrNo) then
    begin
      dvDesktop.allModulesSetIsSelected(False);
      width := 0;
      height := 0;
      for i := 1 to formPasteArray.upDownCount.Position do
      begin
        if modalResult = mrYes then
        begin
          // paste array horizontally
          dvDesktop.paste((width + formPasteArray.upDownDistance.Position) * (i - 1), 0);
        end
        else
        begin
          // paste array vertically
          dvDesktop.paste(0, (height + formPasteArray.upDownDistance.Position) * (i - 1));
        end;
        if width = 0 then
          dvDesktop.selectedModulesGetBounds(top, left, width, height);
      end;
      if Length(dvDesktop.selectedModules) > 0 then
      begin
        dvDesktop.deltaX := 0;
        dvDesktop.deltaY := 0;
        dvDesktop.selectedModulesSetVisible(False);
        dvDesktop.selectedModules[0].BeginDrag(True);
      end;
    end;
  end;
end;

procedure TformLightning.menuItemOpenFromXMLClick(Sender: TObject);
begin
  // hide details window prior to showing dialog
  closeDetails();
  if openDialogXML.Execute then
  begin
    stopTimer();
    try
      dvDesktop.disablePaint();
      try
        new();
        dvDesktop.addFromXMLFile(openDialogXML.FileName, 'lightningdesktop');
      finally
        dvDesktop.enablePaint();
      end;
    finally
      startTimer();
    end;
  end;
end;

procedure TformLightning.menuItemSaveToXMLClick(Sender: TObject);
begin
  // hide details window prior to showing dialog
  closeDetails();
  if saveDialogXML.Execute then
  begin
    stopTimer();
    try
      dvDesktop.disablePaint();
      try
        dvDesktop.toXMLFile(saveDialogXML.FileName, 'lightningdesktop');
      finally
        dvDesktop.enablePaint();
      end;
    finally
      startTimer();
    end;
  end;
end;

procedure TformLightning.menuItemStresstestScreenStickClick(Sender: TObject);
var
  i, j: Integer;
begin
  for j := 1 to 10000 do
  begin
    for i := 0 to Length(dvDesktop.modules) - 1 do
    begin
      if dvDesktop.modules[i].ext = 'in_screenstick.dll' then
      begin
        iSettingsMouseup(dvDesktop.modules[i].iSettings, mbLeft, [], 0, 0);
        Sleep(100);
        closeDetails();
        Sleep(100);
      end;
    end;
  end;
end;

procedure TformLightning.aeEventsMessage(var Msg: tagMSG;
  var Handled: Boolean);
  function windowToClass(window: THandle): string;
  var
    className: array[0..30] of Char;
  begin
    className := '';
    GetClassName(Msg.hwnd, className, 30);
    Result := className;
  end;
var
  className: string;
begin
  if (Msg.message = WM_KEYDOWN) or (Msg.message = WM_KEYUP) then
  begin
    updateKeys();
//    sbStatus.Panels[3].Text :=
//      'key ' + IntToHex(Msg.WParam, 0) + ' ' + IntToHex(Cardinal(Msg.LParam), 0);
    className := windowToClass(Msg.hwnd);
    if (className <> 'TSpinEdit')
       and
       (className <> 'TEdit')
       and
       (className <> 'TKeyEdit')
       then
    begin
      dvDesktop.allModulesKeyboard(Longint(Msg.wParam), Cardinal(Msg.lParam));
    end;
  end;
end;

procedure TformLightning.menuItemTraceClick(Sender: TObject);
begin
  menuItemTrace.Checked := not(menuItemTrace.Checked);
  if formTrace <> nil then
  begin
    formLightning.statusBar.Panels[0].Text := '';
    formTrace.Free();
    formTrace := nil;
  end;
  if menuItemTrace.Checked then
  begin
    formTrace := TformTrace.Create(Self);
    formTrace.Show();
  end;
end;

procedure TformLightning.FormResize(Sender: TObject);
begin
  statusBar.Panels[0].Width :=
    statusBar.Width -
    statusBar.Panels[1].Width -
    statusBar.Panels[2].Width -
    statusBar.Panels[3].Width -
    statusBar.Panels[4].Width;
end;

procedure TformLightning.miToolBarClick(Sender: TObject);
begin
  lightningSettings.toolBar := not(lightningSettings.toolBar);
  miToolBar.Checked := lightningSettings.toolBar;
  toolBar.Visible := lightningSettings.toolBar;
end;

end.
