unit unitthreadtimer;

(* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at 
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the Lightning main timer thread.
 *
 * The Initial Developer of the Original Code is
 * Tomsoft.
 * Portions created by Tomsoft are Copyright (C) 2009
 * Tomsoft. All Rights Reserved.
 *
 * Contributor(s):
 *   Tommy Sools <tom@sools.com>
 *
 * ***** END LICENSE BLOCK ***** *)

interface

uses
  Classes, Windows;

type
  TTimerThread = class(TThread)
  private
    interval: Cardinal;
    procedure timer();
  protected
    procedure Execute(); override;
  public
    constructor Create(CreateSuspended: Boolean; interval: Cardinal);
  end;

implementation

uses
  unitformlightning;

constructor TTimerThread.Create(CreateSuspended: Boolean; interval: Cardinal);
begin
  inherited Create(CreateSuspended);
  Self.interval := interval;
end;

procedure TTimerThread.Execute();
begin
  while not(Terminated) do
  begin
    Sleep(interval);
    Synchronize(timer);
  end;
end;

procedure TTimerThread.timer();
begin
  formLightning.timerProc();
end;

end.
